(in-package #:odo/model-api)

(defsection @odo/model-api/state-constraint (:title "State constraints")
  "State constraints relate the values of variables and state variables at a
single point in time. It responds to the same functions as a constraint, except
the return value of `constraint-expression` is an Odo expression that contain
references to `+CURRENT-TIME+`, representing the time point at which all state
variables are evaluated."
  (odo:state-constraint class)
  (odo:odo-state-constraint class)
  (odo:state-constraint-p generic-function)
  (odo:odo-state-constraint-p generic-function)
  (odo:make-state-constraint function))


;;; Types

(defclass odo:state-constraint (odo:object)
  ()
  (:documentation
   "A state constraint."))

(utils:define-renamed-class odo:odo-state-constraint odo:state-constraint)

(defgeneric odo:state-constraint-p (obj)
  (:documentation
   "Returns T iff `OBJ` is an Odo state constraint.")
  (:method ((obj t))
    nil))

(utils:define-renamed-generic (odo:odo-state-constraint-p odo:state-constraint-p) (obj))


;;; Constructor

(defun odo:make-state-constraint (predicate
                              &key
                                (name (gensym "SC"))
                                annotations
                              &allow-other-keys)
  "Instantiate and return a new state constraint.

`PREDICATE` Must be an instance of an `ODO-EXPRESSION`, using `+CURRENT-TIME+`.

If `NAME` is not supplied, a name is autogenerated."
  (assert (typep (odo:type predicate) 'odo:expression))
  (odo:make-instance 'odo:state-constraint
                     :name name
                     :predicate predicate
                     :annotations annotations))


;;; API

(defmethod odo:equal-p-by-type (left right
                                (left-type odo:state-constraint)
                                (right-type odo:state-constraint))
  (and
   (eq left-type right-type)
   (equal (odo:name left)
          (odo:name right))
   (utils:plist-equal (odo:annotation-plist left)
                      (odo:annotation-plist right))
   (odo:equal-p (odo:expression left)
                (odo:expression right))))


(defmethod odo:copy-by-type (c (type odo:state-constraint) &key context)
  (odo:make-state-constraint (odo:copy (odo:expression c) :context context)
                             :name (odo:name c)
                             :annotations (copy-list (odo:annotation-plist c))))

(defmethod utils:print-odo-object-by-type (c (type odo:state-constraint) stream)
  (utils:odo-print-unreadable-object (c stream)
    (write (class-name (class-of (odo:type c))) :stream stream)
    (write-char #\Space stream)
    (pprint-newline :fill stream)
    (write (odo:name c) :stream stream)
    (write-char #\Space stream)
    (pprint-newline :fill stream)
    (write (odo:expression c) :stream stream)
    (write-char #\Space stream)
    (pprint-newline :fill stream)
    (write :annotations :stream stream)
    (write-char #\Space stream)
    (pprint-newline :fill stream)
    (write (odo:annotation-plist c) :stream stream)))
